JUPYTERHUB(1)

NAME
jupyterhub - Multi-user server for Jupyter notebooks

DESCRIPTION
Start a multi-user Jupyter Notebook server

    Spawns a configurable-http-proxy and multi-user Hub, which authenticates users and spawns single-user Notebook servers on behalf of users.

Subcommands =========== Subcommands are launched as `jupyterhub cmd [args]`. For information on using subcommand 'cmd', do: `jupyterhub cmd -h`.

token

    Generate an API token for a user

upgrade-db

    Upgrade your JupyterHub state database to the current version.

Options ======= The options below are convenience aliases to configurable class-options, as listed in the "Equivalent to" description-line of the aliases. To see all configurable class-options for some <cmd>, use:

    <cmd> --help-all

--debug

    set log level to logging.DEBUG (maximize logging output) Equivalent to: [--Application.log_level=10]

--show-config

    Show the application's configuration (human-readable format) Equivalent to: [--Application.show_config=True]

--show-config-json

    Show the application's configuration (json format) Equivalent to: [--Application.show_config_json=True]

--generate-config

    generate default config file Equivalent to: [--JupyterHub.generate_config=True]

--generate-certs

    generate certificates used for internal ssl Equivalent to: [--JupyterHub.generate_certs=True]

--no-db

    disable persisting state database to disk Equivalent to: [--JupyterHub.db_url=sqlite:///:memory:]

--upgrade-db

    Automatically upgrade the database if needed on startup.

    Only safe if the database has been backed up. Only SQLite database files will be backed up automatically.

    Equivalent to: [--JupyterHub.upgrade_db=True]

--no-ssl

    [DEPRECATED in 0.7: does nothing] Equivalent to: [--JupyterHub.confirm_no_ssl=True]

--base-url=<URLPrefix>

    The base URL of the entire application.

    Add this to the beginning of all JupyterHub URLs. Use base_url to run JupyterHub within an existing website.

    Default: '/' Equivalent to: [--JupyterHub.base_url]

-y=<Bool>

    Answer yes to any questions (e.g. confirm overwrite) Default: False Equivalent to: [--JupyterHub.answer_yes]

--ssl-key=<Unicode>

    Path to SSL key file for the public facing interface of the proxy

    When setting this, you should also set ssl_cert

    Default: '' Equivalent to: [--JupyterHub.ssl_key]

--ssl-cert=<Unicode>

    Path to SSL certificate file for the public facing interface of the proxy

    When setting this, you should also set ssl_key

    Default: '' Equivalent to: [--JupyterHub.ssl_cert]

--url=<Unicode>

    The public facing URL of the whole JupyterHub application.

    This is the address on which the proxy will bind. Sets protocol, ip, base_url

    Default: 'http://:8000' Equivalent to: [--JupyterHub.bind_url]

--ip=<Unicode>

    The public facing ip of the whole JupyterHub application

    (specifically referred to as the proxy). This is the address on which the proxy will listen. The default is to listen on all interfaces. This is the only address through which JupyterHub should be accessed by users.

    Default: '' Equivalent to: [--JupyterHub.ip]

--port=<Int>

    The public facing port of the proxy.

    This is the port on which the proxy will listen. This is the only port through which JupyterHub should be accessed by users.

    Default: 8000 Equivalent to: [--JupyterHub.port]

--pid-file=<Unicode>

    File to write PID

    Useful for daemonizing JupyterHub.

    Default: '' Equivalent to: [--JupyterHub.pid_file]

--log-file=<Unicode>

    DEPRECATED: use output redirection instead, e.g. jupyterhub &>> /var/log/jupyterhub.log Default: '' Equivalent to: [--JupyterHub.extra_log_file]

--log-level=<Enum>

    Set the log level by value or name. Choices: any of [0, 10, 20, 30, 40, 50, 'DEBUG', 'INFO', 'WARN', 'ERROR', 'CRITICAL'] Default: 30 Equivalent to: [--Application.log_level]

-f=<Unicode>

    The config file to load Default: 'jupyterhub_config.py' Equivalent to: [--JupyterHub.config_file]

--config=<Unicode>

    The config file to load Default: 'jupyterhub_config.py' Equivalent to: [--JupyterHub.config_file]

--db=<Unicode>

    url for the database. e.g. `sqlite:///jupyterhub.sqlite` Default: 'sqlite:///jupyterhub.sqlite' Equivalent to: [--JupyterHub.db_url]

Examples --------

    generate default config file:

    jupyterhub --generate-config -f /etc/jupyterhub/jupyterhub_config.py

    spawn the server on 10.0.1.2:443 with https:

    jupyterhub --ip 10.0.1.2 --port 443 --ssl-key my_ssl.key --ssl-cert my_ssl.cert

To see all available configurables, use `--help-all`.

SEE ALSO
The full documentation for jupyterhub is maintained as a Texinfo manual. If the info and jupyterhub programs are properly installed at your site, the command

    info jupyterhub

should give you access to the complete manual.